// USB_Dii_Open.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>
#include <time.h>

#include "USBDII.h"

#include <dos.h>
#include <conio.h>

void delay(int milliseconds)
{
	Sleep(milliseconds);
}
int FoundCard[100][2];
int FoundNum;
void list(){
	if(FoundNum == 0){
		printf("\nNothing found!!");
	}
	else{
		printf("\nFound cards:\n");
		for(int i = 0;i<FoundNum;i++){
			printf("%2i : (%x,%x).\n",i,FoundCard[i][0],FoundCard[i][1]);
		}
	}
}
void printhelp(){
	printf("Accessing USB I/O devices.\n");
	printf("Only supporting USB I/O series from Decision Group INC.\n");
	printf("\nUSBDIICMD [/o DeviceID CardID][/w port value][/r port][/l][/?]\n\n");
	printf("  /o \t\tOpen Decision Group USB Series devices.\n");
	printf("  DeviceID\tCard type of the device.\n");
	printf("  \tUSB_16PIO:01\tUSB_LABKIT:02\tUSB_16PR:03\tUSB_STARTER:04\n");
	printf("  \tUSB_8PR:06\tUSB_4PR:07\tUSB_8PI:08\tUSB_8RO:09\t\n");
	printf("  \tUSB_16PI:10\tUSB_16RO:11\tUSB_32PI:12\tUSB_32RO:13\n");
	printf("  CardID\tOnboard switch setting (0~14).\n");
	printf("  /w \t\tWrite value to port.\n");
	printf("    port\tPort number to write.\n");
	printf("    value\tWrite value.\n");
	printf("  /r \t\tRead port.\n");
	printf("    port\tPort number to read.\n");
	printf("  /l \t\tList all devices.\n");
	printf("  /? \t\tPrint this help.\n");
}

int _tmain(int argc, _TCHAR* argv[])
{
	UINT card_id = 0x01;
	UINT card_number = 0x00;
	unsigned char read_data = 0;
	int i,port;
	BYTE data;
	int test_data = 0x01;
	HANDLE hUSB = INVALID_HANDLE_VALUE;

	FoundNum = 0;

	i = 1;
	if(argc == 1){
		printhelp();
		return 0;
	}
	do{
		switch(argv[i][0]){
		case '/':{
			switch(argv[i][1]){
				case 'o':case 'O':{//open
					card_id = atoi(argv[i+1]);
					card_number = atoi(argv[i+2]);
					hUSB = hid_OpenDevice(card_id,card_number);
					if(hUSB == INVALID_HANDLE_VALUE){
						printf("Open failed");
					}
					break;
				}
				case 'w':case 'W':{//write
					if(hUSB == INVALID_HANDLE_VALUE){
						printf("\nInvalid device\n");
						break;
					}
					if(i + 2 >= argc){
						printf("\nInvalid parameter\n");
						break;
					}
					port = atoi(argv[i+1]);
					data = atoi(argv[i+2]);
					hid_write(hUSB,port,data);
					break;
				}
				case 'r':case 'R':{//read
					if(hUSB == INVALID_HANDLE_VALUE){
						printf("\nInvalid device\n");
						return 0;
					}
					if(i + 1 >= argc){
						printf("\nInvalid parameter\n");
						break;
					}
					port = atoi(argv[i+1]);
					hid_read(hUSB,port,&data);
					printf("%d",data);
					break;
				}
				case 'l':case 'L':{//list
					for(int i = 0;i<0x20;i++){
					printf("\rFinding");
					if(i%3 == 0)
						printf(".  \b\b");
					if(i%3 == 1)
						printf(".. \b");
					if(i%3 == 2)
						printf("...");
					for(int j = 0;j<0xf;j++){
						hUSB = hid_OpenDevice(i,j);
	 					//printf("Finding card:%h,%h",i,j);
						if((hUSB!=INVALID_HANDLE_VALUE)&&(hUSB!=0)){
							printf("\nFound card:%x,%x\n",i,j);
							FoundCard[FoundNum][0] = i;
							FoundCard[FoundNum][1] = j;
							FoundNum++;
							}
						}
					}
					list();
					break;
				}
				case '?':{
					printhelp();
					break;
				}
				default:{
					printf("invalid parameter");
					break;
				}
			}
			break;
		}
		default:{
			break;
		}
		}
		i++;
	}while(i < argc);
	return 0;
}